
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Arrangement_sectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const arrangement_sections = await db.arrangement_sections.create(
            {
                id: data.id || undefined,
        
        section_type: data.section_type
        ||
        null
            ,
            
        label: data.label
        ||
        null
            ,
            
        start_bar: data.start_bar
        ||
        null
            ,
            
        bar_length: data.bar_length
        ||
        null
            ,
            
        order_index: data.order_index
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await arrangement_sections.setSong( data.song || null, {
            transaction,
        });
        
        await arrangement_sections.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return arrangement_sections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const arrangement_sectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                section_type: item.section_type
            ||
            null
            ,
            
                label: item.label
            ||
            null
            ,
            
                start_bar: item.start_bar
            ||
            null
            ,
            
                bar_length: item.bar_length
            ||
            null
            ,
            
                order_index: item.order_index
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const arrangement_sections = await db.arrangement_sections.bulkCreate(arrangement_sectionsData, { transaction });

        // For each item created, replace relation files
        

        return arrangement_sections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const arrangement_sections = await db.arrangement_sections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.section_type !== undefined) updatePayload.section_type = data.section_type;
        
        
        if (data.label !== undefined) updatePayload.label = data.label;
        
        
        if (data.start_bar !== undefined) updatePayload.start_bar = data.start_bar;
        
        
        if (data.bar_length !== undefined) updatePayload.bar_length = data.bar_length;
        
        
        if (data.order_index !== undefined) updatePayload.order_index = data.order_index;
        
        
        updatePayload.updatedById = currentUser.id;

        await arrangement_sections.update(updatePayload, {transaction});

        
        
        if (data.song !== undefined) {
            await arrangement_sections.setSong(
              
              data.song,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await arrangement_sections.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return arrangement_sections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const arrangement_sections = await db.arrangement_sections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of arrangement_sections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of arrangement_sections) {
                await record.destroy({transaction});
            }
        });


        return arrangement_sections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const arrangement_sections = await db.arrangement_sections.findByPk(id, options);

        await arrangement_sections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await arrangement_sections.destroy({
            transaction
        });

        return arrangement_sections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const arrangement_sections = await db.arrangement_sections.findOne(
            { where },
            { transaction },
        );

        if (!arrangement_sections) {
            return arrangement_sections;
        }

        const output = arrangement_sections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.song = await arrangement_sections.getSong({
            transaction
        });
        
        
        output.organizations = await arrangement_sections.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.songs,
        as: 'song',
        
        where: filter.song ? {
          [Op.or]: [
            { id: { [Op.in]: filter.song.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.song.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'arrangement_sections',
                        'label',
                        filter.label,
                    ),
                };
            }
            

            
            

            
            if (filter.start_barRange) {
                const [start, end] = filter.start_barRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_bar: {
                    ...where.start_bar,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_bar: {
                    ...where.start_bar,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.bar_lengthRange) {
                const [start, end] = filter.bar_lengthRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    bar_length: {
                    ...where.bar_length,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    bar_length: {
                    ...where.bar_length,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.order_indexRange) {
                const [start, end] = filter.order_indexRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_index: {
                    ...where.order_index,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.section_type) {
                where = {
                    ...where,
                section_type: filter.section_type,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.arrangement_sections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'arrangement_sections',
                        'label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.arrangement_sections.findAll({
            attributes: [ 'id', 'label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.label,
        }));
    }

    
};

